indexing
	description
		"ISE/SE Compatability features"
		"Source is .ge, don't change the .e file"

deferred class
	CL_MISC
	
inherit
	STRING_HANDLER

feature -- Access

	rv: INTEGER

	ptr_to_str (p: POINTER): STRING is

		do
			create Result.from_external_copy (p)
		end

	terminated (str: STRING): POINTER is

		do
			Result := str.to_external

		end

	str_to_ptr (str: STRING): POINTER is
		-- This pointer must be good for both string reads and writes

		do
			Result := str.to_external
		end

	array_to_ptr (array: ARRAY[DOUBLE]): POINTER is
		-- This pointer must be good for both string reads and writes

		do
			Result := array.to_external
		end

	prune_all_leading (s: STRING; c: CHARACTER): STRING is

		local
			i: INTEGER
			fin: BOOLEAN
		do
			Result := s.twin
			fin := false
			from i := 1
			until fin or i > Result.count
			loop
				if c = Result.item (i) then
					i := i + 1
				else
					fin := true
				end
			end
			if i > 1 then
				if i <= Result.count then 
					Result.storage.move (i - 1, Result.count - 1, 1 - i)
				end
				Result.resize (Result.count + 1 - i)
			end	
		end

	is_hexa_digit (ch: CHARACTER): BOOLEAN is

		do
			Result := (ch >= '0' and ch <= '9')
				or else (ch >= 'a' and ch <= 'f')
				or else (ch >= 'A' and ch <= 'F')
		end

	double_to_real (d: DOUBLE): REAL is

		do
			Result := d
		end

	Ec_ise: CHARACTER is 'I'
	Ec_se: CHARACTER is 'S'

	Eiffel_compiler: CHARACTER is 'S'

end -- class CL_MISC

