<?xml version="1.0" encoding="ISO-8859-1"?>

<!--
     change external_library to external_object
     remove GOBO ELKS libraries
     add ISE library elements
     Works for Eiffel Studio 6
-->

<xsl:stylesheet
  version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:t="http://www.eiffel.com/developers/xml/configuration-1-3-0"
  exclude-result-prefixes="t"
>

<xsl:output method="xml" encoding="ISO-8859-1"/>

<xsl:template match="/t:system">
  <xsl:copy>
    <xsl:apply-templates select="@* | *"/>
  </xsl:copy>
</xsl:template>

<xsl:template match="t:target"> <!-- add library elements -->
  <xsl:copy>
    <xsl:apply-templates select="@* | *"/>
    <xsl:element name="library" xmlns="http://www.eiffel.com/developers/xml/configuration-1-3-0">
      <xsl:attribute name="name">base</xsl:attribute>
      <xsl:attribute name="location">$ISE_LIBRARY\library\base\base.ecf</xsl:attribute>
    </xsl:element>
    <xsl:element name="library" xmlns="http://www.eiffel.com/developers/xml/configuration-1-3-0">
      <xsl:attribute name="name">time</xsl:attribute>
      <xsl:attribute name="location">$ISE_LIBRARY\library\time\time.ecf</xsl:attribute>
    </xsl:element>
  </xsl:copy>
</xsl:template>

<xsl:template match="t:external_library">
  <xsl:element name="external_object" xmlns="http://www.eiffel.com/developers/xml/configuration-1-3-0">
    <xsl:attribute name="location">
      <xsl:value-of select="@location"/>
    </xsl:attribute>
  </xsl:element>
</xsl:template>

<xsl:template match="t:cluster"> <!-- remove ELKS clusters -->
  <xsl:if test="not (starts-with (@location, '${ELKS}'))">
    <xsl:copy-of select="."/>
  </xsl:if>
</xsl:template>

<xsl:template match="t:root|t:setting|t:external_include|t:assertions">
  <xsl:copy-of select="."/>
</xsl:template>

<xsl:template match="t:option">
  <xsl:copy>
    <xsl:apply-templates select="@* | *"/>
  </xsl:copy>
</xsl:template>

<xsl:template match="@*">
  <xsl:copy-of select="."/>
</xsl:template>

</xsl:stylesheet>
