<?xml version="1.0" encoding="ISO-8859-1"?>

<!DOCTYPE xyz [
<!ENTITY nl "&#x0A;">
<!ENTITY tab "&#x09;">
]>

<!-- 
Create a SmartEiffel ace file from a xace file.
This codes does not properly parse all the SmartEiffel options
extension used for node-set ()
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:exsl="http://exslt.org/common"
extension-element-prefixes="exsl"
version="1.0">

<xsl:output method="text" />
<xsl:param name="platform"/>
<!--xsl:param name="project"/>
<xsl:param name="compiler"/>
<xsl:param name="source"/>
<xsl:param name="local"/-->

<!--xsl:include href="replace.xsl" />
<xsl:include href="options.xsl" /-->

<xsl:template match="/system">
  <xsl:text>system&nl;&nl;&tab;"</xsl:text>
  <xsl:value-of select="@name"/>
  <xsl:text>"&nl;&nl;root&nl;&nl;&tab;</xsl:text>
  <xsl:value-of select="root/@class"/>
  <xsl:text>: </xsl:text>
  <xsl:value-of select="root/@creation"/>
  <xsl:text>

default

	assertion (all)
	debug (no)
	collect (yes)
	high_memory_compiler (no)
	manifest_string_trace (no)
	trace (no)
	verbose (no)
	no_style_warning (yes)
	no_warning (yes)&nl;</xsl:text>

  <xsl:if test="option[@name='profile' and @value='true']">
    <xsl:text>&tab;profile (yes)&nl;</xsl:text>
  </xsl:if>

  <xsl:text>&nl;cluster&nl;&nl;</xsl:text>
  <xsl:for-each select="cluster">
    <xsl:if test="not (starts-with (@location, '${ELKS}'))">
      <xsl:text>&tab;</xsl:text>
      <xsl:value-of select="@name"/>
      <xsl:text>: "</xsl:text>
      <xsl:value-of select="@location"/>
      <xsl:text>"&nl;</xsl:text>
    </xsl:if>	
  </xsl:for-each>
  <xsl:text>&tab;lib: "${SmartEiffelDirectory}/lib/loadpath.se"&nl;</xsl:text>
  <xsl:text>&nl;external&nl;&nl;</xsl:text>

  <xsl:variable name="pmatch"> 
    <xsl:text>${PLATFORM}=</xsl:text>
    <xsl:value-of select="$platform"/>
  </xsl:variable> 
  <xsl:variable name="headers"> 
    <xsl:for-each select="option[@name='header']|option[@if=$pmatch]/option[@name='header']">
      <header><xsl:value-of select="@value"/></header>
    </xsl:for-each>
  </xsl:variable>

  <xsl:if test="count (exsl:node-set($headers)/header) &gt; 0">
    <xsl:text>&tab;external_header_path:&nl;&tab;&tab;"</xsl:text>
    <xsl:for-each select="exsl:node-set($headers)/header">
      <xsl:if test="position () &gt; 1">
        <xsl:text> </xsl:text>
      </xsl:if>
      <xsl:value-of select="node ()"/>
    </xsl:for-each>
    <xsl:text>"&nl;</xsl:text>
  </xsl:if>

  <xsl:variable name="objects"> 
    <xsl:for-each select="option[@name='link']|option[@if=$pmatch]/option[@name='link']">
      <object><xsl:value-of select="@value"/></object>
    </xsl:for-each>
  </xsl:variable>

  <xsl:if test="count (exsl:node-set($objects)/object) &gt; 0">
    <xsl:text>&tab;external_lib:&nl;&tab;&tab;"</xsl:text>
    <xsl:for-each select="exsl:node-set($objects)/object">
      <xsl:if test="position () &gt; 1">
        <xsl:text> </xsl:text>
      </xsl:if>
      <xsl:value-of select="node ()"/> 
    </xsl:for-each>
    <xsl:text>"&nl;</xsl:text>
  </xsl:if>

  <xsl:text>
generate

	clean (no)
	gc_info (no)
	no_split (yes)
	no_strip (no)
	no_main (no)
	wedit (no)

end&nl;</xsl:text>
</xsl:template>

</xsl:stylesheet>
