indexing
	description:
		"A means of traversing a polymorphic linked list."
		"Created by calling PLIST[G].new_cursor."

class
	PCURSOR[G]

create
	make

feature {PLIST} -- Creation

	make (list: PLIST[G]) is

		do
			data := list
			node := list.first
		end

feature  -- Access

	data: PLIST[G]

	item: G is
			-- Return the current object referenced by the cursor.
		do
			Result := node.item
		end

	after: BOOLEAN is
			-- Return true is the cursor has reached the end of the list.
		do
			Result := node = Void
		end

	forth is
			-- Move the cursor to the next object in the list.
		do
			node := node.next
		end

	replace (object: G) is
			-- Replace the object referenced by the cursor.
		do
			node.set_item (object)
		end

	remove is
			-- Remove the object referenced by the cursor.
		do
			data.remove_node (node)
			node := node.next
		end

feature {PLIST} -- Restricted

	node: PNODE[G]

end
