indexing
	description:
		"Xerces DOMElement interface"
		"using terminated for string reads"

class
	DOM_ELEMENT

inherit
	DOM_NODE

create
	make

feature -- Access

	tag_name: STRING is
			-- First function can have the side-effect
			-- of setting the transcode buffer
		do
			Result := get_transcoded (de_get_tag_name (obj))
		end

	get_attribute (name: STRING): STRING is
			-- First function can have the side-effect
			-- of setting the transcode buffer
		do
			Result := get_transcoded (de_get_attribute (obj, terminated (name)))
		end

	attributes: DOM_NAMED_NODE_MAP is
			--
		do
			create Result.make (de_get_attributes (obj))
		end

	get_elements_by_tag_name (tagname: STRING): DOM_NODE_LIST is

		do
			create Result.make (
				de_get_elements_by_tag_name (obj, terminated (tagname))
			)
		end

	remove_attribute (name: STRING) is

		do
			de_remove_attribute (obj, terminated (name))
		end

	set_attribute (name, value: STRING) is

		do
			de_set_attribute (obj, terminated (name), terminated (value))
		end

feature {} -- External

	de_get_tag_name (object: POINTER): INTEGER is

		external
			"C | %"dom_support.h%""
		end

	de_get_attribute (object, name: POINTER): INTEGER is

		external
			"C | %"dom_support.h%""
		end

	de_get_attributes (object: POINTER): POINTER is

		external
			"C | %"dom_support.h%""
		end

	de_get_elements_by_tag_name (object, tag: POINTER): POINTER is
			-- return DOMNodeList
		external
			"C | %"dom_support.h%""
		end

	de_set_attribute (object, name, value: POINTER) is

		external
			"C | %"dom_support.h%""
		end

	de_remove_attribute (object, name: POINTER) is

		external
			"C | %"dom_support.h%""
		end

end
