indexing
	description:
		"Xalan FormatterToXML interface"
		"C++ support objects are created dynamically"

class
	FORMATTER_TO_XML

create
	make

feature -- Creation

	make (stream: POINTER) is
			--
		do
			cpp_xsos := xsos_create (stream)
			cpp_xospw := xospw_create (cpp_xsos)
			obj := ftx_create (cpp_xospw)
		end

	dispose is
			--
		do
			ftx_delete (obj)
			xospw_delete (cpp_xospw)
			xsos_delete (cpp_xsos)
		end

feature -- Access

	set_do_indent (flag: BOOLEAN) is

		do
			ftx_set_do_indent (obj, flag)
		end

	set_indent (indent: INTEGER) is

		do
			ftx_set_indent (obj, indent)
		end

	serialize (doc: DOM_DOCUMENT) is
			--
		do
			ftx_serialize (obj, doc.obj)
		end

feature {} -- Private

	obj: POINTER
	cpp_xsos, cpp_xospw: POINTER -- Xalan C++ objects

feature {} -- External

	ftx_create (xospw: POINTER): POINTER is

		external
			"C | %"dom_support.h%""
		end

	ftx_delete (object: POINTER) is

		external
			"C | %"dom_support.h%""
		end

	ftx_set_do_indent (object: POINTER; flag: BOOLEAN) is

		external
			"C | %"dom_support.h%""
		end

	ftx_set_indent (object: POINTER; indent: INTEGER) is

		external
			"C | %"dom_support.h%""
		end

	ftx_serialize (object, document: POINTER) is

		external
			"C | %"dom_support.h%""
		end

feature -- XalanStdOutputStream

	xsos_create (stream: POINTER): POINTER is
			-- takes regular C++ stream as argument
		external
			"C | %"dom_support.h%""
		end

	xsos_delete (object: POINTER) is

		external
			"C | %"dom_support.h%""
		end

feature -- XalanOutputStreamPrintWriter

	xospw_create (xsos: POINTER): POINTER is

		external
			"C | %"dom_support.h%""
		end

	xospw_delete (object: POINTER) is

		external
			"C | %"dom_support.h%""
		end

end
