indexing
	description:
		"XercesDOMParser interface"

class
	XERCES_DOM_PARSER

inherit
	UTF_SUPPORT
	CL_MISC

create
	make

feature -- Creation

	make is
			--
		do
			obj := xdp_create
		end

	dispose is
			--
		do
			xdp_delete (obj)
		end

feature -- Access

	Val_never: INTEGER is 0
	Val_always: INTEGER is 1
	Val_auto: INTEGER is 2

	set_validation_scheme (scheme: INTEGER) is

		do
			xdp_set_validation_scheme (obj, scheme)
		end

	set_do_schema (flag: BOOLEAN) is

		do
			xdp_set_do_schema (obj, flag)
		end

	set_do_namespaces (flag: BOOLEAN) is

		do
			xdp_set_do_namespaces (obj, flag)
		end

	set_include_ignorable_whitespace (flag: BOOLEAN) is

		do
			xdl_set_include_ignorable_whitespace (obj, flag)
		end

	set_error_handler (handler: POINTER) is

		do
			xdl_set_error_handler (obj, handler)
		end

	parse_file (file_name: STRING): DOM_DOCUMENT is

		do
			create Result.make_releasable (
				parse_dom_file (obj, terminated (file_name))
			)
		end

	parse_memory (xml_data: STRING): DOM_DOCUMENT is

		do
			create Result.make_releasable (
				parse_dom_mem (obj, terminated (xml_data), xml_data.count)
			)
		end

feature {} -- Private

	obj: POINTER

feature {} -- External

	xdp_create: POINTER is

		external
			"C | %"dom_support.h%""
		end

	xdp_delete (object: POINTER) is

		external
			"C | %"dom_support.h%""
		end

	xdp_set_validation_scheme (object: POINTER; scheme: INTEGER) is

		external
			"C | %"dom_support.h%""
		end

	xdp_set_do_schema (object: POINTER; flag: BOOLEAN) is

		external
			"C | %"dom_support.h%""
		end

	xdp_set_do_namespaces (object: POINTER; flag: BOOLEAN) is

		external
			"C | %"dom_support.h%""
		end

	xdl_set_include_ignorable_whitespace (object: POINTER; flag: BOOLEAN) is

		external
			"C | %"dom_support.h%""
		end

	xdl_set_error_handler (object, handler: POINTER) is

		external
			"C | %"dom_support.h%""
		end

	parse_dom_file (object, filename: POINTER): POINTER is

		external
			"C | %"dom_support.h%""
		end

	parse_dom_mem (object, buffer: POINTER; buffer_size: INTEGER): POINTER is

		external
			"C | %"dom_support.h%""
		end

end
