indexing
	description:
		"Xerces node factory"

class
	XERCES_NODE_FACTORY

inherit
	NODE_TYPES

create
	make

feature -- Creation

	make is
			--
		do
		end

feature -- Access

	create_dom_node (object: POINTER): DOM_NODE is

		local
			type: INTEGER
			element: DOM_ELEMENT
			attrib: DOM_ATTRIBUTE
			text: DOM_TEXT
			comment: DOM_COMMENT
		do
			if object /= default_pointer then
				type := dn_get_node_type (object)
				inspect type
				when Element_node then
					create element.make (object)
					Result := element
				when Attribute_node then
					create attrib.make (object)
					Result := attrib
				when Text_node then
					create text.make (object)
					Result := text
				--when Cdata_section_node then
				--when Entity_reference_node then
				--when Entity_node then
				--when Processing_instruction_node then
				when Comment_node then
					create comment.make (object)
					Result := comment
				--when Document_node then
				--when Document_type_node then
				--when Document_fragment_node then
				--when Notation_node then
				end
			end
		end

feature -- Documents

	create_document (root_tag, dtd: STRING): DOM_DOCUMENT is
			--
		do
			create Result.make (root_tag, dtd)
		end

	referenced_document (p: POINTER): DOM_DOCUMENT is
			-- Use this to subclass an existing document.
		do
			create Result.make_reference (p)
		end

feature {} -- External

	dn_get_node_type (object: POINTER): INTEGER is

		external
			"C | %"dom_support.h%""
		end

end

